Index: src/edu/ucsb/nceas/metacat/DocumentImpl.java
===================================================================
--- src/edu/ucsb/nceas/metacat/DocumentImpl.java	(revision 6743)
+++ src/edu/ucsb/nceas/metacat/DocumentImpl.java	(revision 6744)
@@ -1268,15 +1268,14 @@
                     // if it is inline data first to get the inline data
                     // internal id
                     String fileName = currentNode.getNodeData();
-                    String accessfileName = 
-                    	DocumentUtil.getDocIdWithoutRevFromInlineDataID(fileName);
+                    // use full docid with revision
+                    String accessfileName = fileName; //DocumentUtil.getDocIdWithoutRevFromInlineDataID(fileName);
+                    
                     // check if user has read permision for this inline data
                     boolean readInlinedata = false;
                     try {
                         Hashtable<String, String> unReadableInlineDataList =
-                            PermissionController
-                                .getUnReadableInlineDataIdList(accessfileName,
-                                        user, groups, true);
+                            PermissionController.getUnReadableInlineDataIdList(accessfileName, user, groups);
                         if (!unReadableInlineDataList.containsValue(fileName)) {
                             readInlinedata = true;
                         }
@@ -1417,10 +1416,9 @@
 			
 			// get a list of inline data sections that are not readable
 			// by this user
+			String fullDocid = docid + "." + rev;
             Hashtable<String, String> unReadableInlineDataList =
-                PermissionController
-                    .getUnReadableInlineDataIdList(docid,
-                            user, groups, true);
+                PermissionController.getUnReadableInlineDataIdList(fullDocid, user, groups);
             
             // If this is for each unreadable section, strip the inline data
 			// from the doc
@@ -2753,13 +2751,17 @@
         }
 
         if (action.equals("UPDATE")) {
-            // check for 'write' permission for 'user' to update this document
-            if (!hasWritePermission(user, groups, accnum) 
+			// check for 'write' permission for 'user' to update this document
+        	// use the previous revision to check the permissions
+            String docIdWithoutRev = DocumentUtil.getSmartDocId(accnum);
+        	int latestRev = DBUtil.getLatestRevisionInDocumentTable(docIdWithoutRev);
+        	String latestDocId = docIdWithoutRev + "." + latestRev;
+            if (!hasWritePermission(user, groups, latestDocId) 
             		&& !AuthUtil.isAdministrator(user, groups)) {
                 throw new Exception(
                     "User " + user
                     + " does not have permission to update XML Document #"
-                    + accnum); }
+                    + latestDocId); }
         }
         XMLReader parser = null;
         try {
@@ -3267,35 +3269,10 @@
             
             // Now delete it from xml_access table
             /*************** DO NOT DELETE ACCESS - need to archive this ******************/
-//            pstmt = conn.prepareStatement(
-//                    "DELETE FROM xml_access WHERE accessfileid = ?");
-//            pstmt.setString(1, docid);
-//            logMetacat.debug("DocumentImpl.delete - executing SQL: " + pstmt.toString());
-//            pstmt.execute();
-//            pstmt.close();
-//            conn.increaseUsageCount(1);
-//            double afterDeleteXmlAccess1 = System.currentTimeMillis()/1000;
-//            logMetacat.info("DocumentImpl.delete - The deleting xml_access base one accessfileid time is "+(afterDeleteXmlAccess1 - afterDeleteIndex ));
-//            pstmt = conn.prepareStatement(
-//                    "DELETE FROM xml_access WHERE docid = ?");
-//            pstmt.setString(1, docid);
-//            logMetacat.debug("DocumentImpl.delete - executing SQL: " + pstmt.toString());
-//            pstmt.execute();
-//            pstmt.close();
-//            conn.increaseUsageCount(1);
             double afterDeleteXmlAccess2 = System.currentTimeMillis()/1000;
-//            logMetacat.info("DocumentImpl.delete - The deleting xml_access base on docid time is "+(afterDeleteXmlAccess2 - afterDeleteXmlAccess1 ));
-            /******* END DELETE ACCESS *************/
+            /******* END DELETE ACCESS *************/            
+            // Delete enteries from xml_queryresult
 
-            
-            // Delete enteries from xml_queryresult
-//            pstmt = conn.prepareStatement(
-//                    "DELETE FROM xml_queryresult WHERE docid = ?");
-//            pstmt.setString(1, docid);
-//            logMetacat.debug("DocumentImpl.delete - running sql: " + pstmt.toString());
-//            pstmt.execute();
-//            pstmt.close();
-//            conn.increaseUsageCount(1);
             try {
                 XMLQueryresultAccess xmlQueryresultAccess = new XMLQueryresultAccess();
                 xmlQueryresultAccess.deleteXMLQueryresulForDoc(docid);
Index: src/edu/ucsb/nceas/metacat/MetacatHandler.java
===================================================================
--- src/edu/ucsb/nceas/metacat/MetacatHandler.java	(revision 6743)
+++ src/edu/ucsb/nceas/metacat/MetacatHandler.java	(revision 6744)
@@ -658,9 +658,9 @@
             if (inlineDataId == null || inlineDataId.equals("")) {
                 throw new Exception("You didn't specify requested inlinedataid"); }
             
-            // check for permission
-            docId = 
-                DocumentUtil.getDocIdWithoutRevFromInlineDataID(inlineDataId);
+            // check for permission, use full docid with revision
+            docId = DocumentUtil.getDocIdFromInlineDataID(inlineDataId);
+
             PermissionController controller = new PermissionController(docId);
             // check top level read permission
             if (!controller.hasPermission(user, groups,
@@ -672,10 +672,8 @@
                 //check data access level
                 try {
                     Hashtable<String,String> unReadableInlineDataList =
-                            PermissionController.getUnReadableInlineDataIdList(docId,
-                            user, groups, false);
-                    String inlineDataIdWithoutRev = DocumentUtil.getInlineDataIdWithoutRev(inlineDataId);
-                    if (unReadableInlineDataList.containsValue(inlineDataIdWithoutRev)) {
+                            PermissionController.getUnReadableInlineDataIdList(docId, user, groups);
+                    if (unReadableInlineDataList.containsValue(inlineDataId)) {
                         throw new Exception("User " + user
                                 + " doesn't have permission " + " to read inlinedata "
                                 + inlineDataId);
@@ -1851,7 +1849,7 @@
                   // handle inserts
                   try {
                 	// create the system metadata  
-                    sysMeta = SystemMetadataFactory.createSystemMetadata(newdocid, true);
+                    sysMeta = SystemMetadataFactory.createSystemMetadata(newdocid, false);
                     
                     // save it to the map
                     HazelcastService.getInstance().getSystemMetadataMap().put(sysMeta.getIdentifier(), sysMeta);
@@ -2994,7 +2992,7 @@
                                     username, groupnames);
                             
                             // generate system metadata about the doc
-                            SystemMetadata sm = SystemMetadataFactory.createSystemMetadata(docid, true);
+                            SystemMetadata sm = SystemMetadataFactory.createSystemMetadata(docid, false);
 							
 					        // manage it in the store
                             HazelcastService.getInstance().getSystemMetadataMap().put(sm.getIdentifier(), sm);
Index: src/edu/ucsb/nceas/metacat/util/DocumentUtil.java
===================================================================
--- src/edu/ucsb/nceas/metacat/util/DocumentUtil.java	(revision 6743)
+++ src/edu/ucsb/nceas/metacat/util/DocumentUtil.java	(revision 6744)
@@ -390,12 +390,12 @@
      * Method to get docidwithrev from eml2 inline data id The eml inline data
      * id would look like eml.200.2.3
      */
-    public static String getDocIdWithoutRevFromInlineDataID(String inlineDataID)
+    public static String getDocIdFromInlineDataID(String inlineDataID)
     {
         String docidWithoutRev = null;
         if (inlineDataID == null) { return docidWithoutRev; }
         char charSeperator = separator;
-        int targetNumberOfSeperator = 2;// we want to know his index
+        int targetNumberOfSeperator = 3;// we want to know his index
         int numberOfSeperator = 0;
         for (int i = 0; i < inlineDataID.length(); i++) {
             // meet seperator, increase number of seperator
Index: src/edu/ucsb/nceas/metacat/dataone/SystemMetadataFactory.java
===================================================================
--- src/edu/ucsb/nceas/metacat/dataone/SystemMetadataFactory.java	(revision 6743)
+++ src/edu/ucsb/nceas/metacat/dataone/SystemMetadataFactory.java	(revision 6744)
@@ -286,8 +286,8 @@
 			}
 		}
 		
-		// look up the access control policy we have in metacat already to make sure it is in the SM
-		AccessPolicy accessPolicy = IdentifierManager.getInstance().getAccessPolicyByLocalId(docidWithoutRev);
+		// look up the access control policy we have in metacat
+		AccessPolicy accessPolicy = IdentifierManager.getInstance().getAccessPolicy(guid);
 		sysMeta.setAccessPolicy(accessPolicy);
 		
 		// authoritative node
@@ -325,123 +325,126 @@
 	            List<Identifier> dataIds = new ArrayList<Identifier>();
 				
 				// iterate through data objects described by the EML
-				for (int j = 0; j < dataPackage.getEntityList().length; j++) {
-
-					String dataDocUrl = dataPackage.getEntityList()[j].getURL();
-					String dataDocMimeType = dataPackage.getEntityList()[j].getDataFormat();
-					// default to binary
-					if (dataDocMimeType == null) {
-						dataDocMimeType = ObjectFormatCache.getInstance()
-								.getFormat("application/octet-stream")
-								.getFormatId().getValue();
-					}
-					String dataDocLocalId = "";
-					logMetacat.debug("Data local ID: " + dataDocLocalId);
-					logMetacat.debug("Data URL     : " + dataDocUrl);
-					logMetacat.debug("Data mime    : " + dataDocMimeType);
-
-					// we only handle ecogrid urls right now
-					String ecogridPrefix = "ecogrid://knb/";
-					if (dataDocUrl.trim().startsWith(ecogridPrefix)) {
-						dataDocLocalId = dataDocUrl.substring(dataDocUrl
-								.indexOf(ecogridPrefix)
-								+ ecogridPrefix.length());
-
-						// look up the guid for the data
-						String dataDocid = DocumentUtil.getSmartDocId(dataDocLocalId);
-						int dataRev = DocumentUtil.getRevisionFromAccessionNumber(dataDocLocalId);
-
-						// check if data system metadata exists already
-						SystemMetadata dataSysMeta = null;
-						String dataGuidString = null;
-						Identifier dataGuid = new Identifier();
-						try {
-							// look for the identifier
-							dataGuidString = IdentifierManager.getInstance().getGUID(dataDocid, dataRev);
-							// set it
-							dataGuid.setValue(dataGuidString);
-							// look up the system metadata
-							try {
-								dataSysMeta = HazelcastService.getInstance().getSystemMetadataMap().get(dataGuid);
-							} catch (Exception e) {
-								// probably not in the system
-								dataSysMeta = null;
-							}
-							//dataSysMeta = IdentifierManager.getInstance().getSystemMetadata(dataGuidString);
-						} catch (McdbDocNotFoundException nf) {
-							// we didn't find it
-							dataSysMeta = null;
+	            if (dataPackage.getEntityList() != null) {
+					for (int j = 0; j < dataPackage.getEntityList().length; j++) {
+	
+						String dataDocUrl = dataPackage.getEntityList()[j].getURL();
+						String dataDocMimeType = dataPackage.getEntityList()[j].getDataFormat();
+						// default to binary
+						if (dataDocMimeType == null) {
+							dataDocMimeType = ObjectFormatCache.getInstance()
+									.getFormat("application/octet-stream")
+									.getFormatId().getValue();
 						}
-							
-						// we'll have to generate it	
-						if (dataSysMeta == null) {
-							// System metadata for data doesn't exist yet, so create it
-							logMetacat.debug("There was not an existing system metadata document for " + dataDocLocalId);
+						String dataDocLocalId = "";
+						logMetacat.debug("Data local ID: " + dataDocLocalId);
+						logMetacat.debug("Data URL     : " + dataDocUrl);
+						logMetacat.debug("Data mime    : " + dataDocMimeType);
+	
+						// we only handle ecogrid urls right now
+						String ecogridPrefix = "ecogrid://knb/";
+						if (dataDocUrl.trim().startsWith(ecogridPrefix)) {
+							dataDocLocalId = dataDocUrl.substring(dataDocUrl
+									.indexOf(ecogridPrefix)
+									+ ecogridPrefix.length());
+	
+							// look up the guid for the data
+							String dataDocid = DocumentUtil.getSmartDocId(dataDocLocalId);
+							int dataRev = DocumentUtil.getRevisionFromAccessionNumber(dataDocLocalId);
+	
+							// check if data system metadata exists already
+							SystemMetadata dataSysMeta = null;
+							String dataGuidString = null;
+							Identifier dataGuid = new Identifier();
 							try {
-								logMetacat.debug("Creating a system metadata " + "document for " + dataDocLocalId);
-								dataSysMeta = createSystemMetadata(dataDocLocalId, includeORE);
-
-								// now look it up again
+								// look for the identifier
 								dataGuidString = IdentifierManager.getInstance().getGUID(dataDocid, dataRev);
-
-								// set the guid
+								// set it
 								dataGuid.setValue(dataGuidString);
-
-								// set object format
-								logMetacat.debug("Updating system metadata for "
-												+ dataGuid.getValue() + " to "
-												+ dataDocMimeType);
+								// look up the system metadata
 								try {
-									ObjectFormatIdentifier fmt = 
-										ObjectFormatCache.getInstance().getFormat(dataDocMimeType).getFormatId();
-									dataSysMeta.setFormatId(fmt);
-								} catch (NotFound nfe) {
-									logMetacat.debug("Couldn't find format identifier for: "
-													+ dataDocMimeType
-													+ ". Setting it to application/octet-stream.");
-									ObjectFormatIdentifier newFmtid = new ObjectFormatIdentifier();
-									newFmtid.setValue("application/octet-stream");
+									dataSysMeta = HazelcastService.getInstance().getSystemMetadataMap().get(dataGuid);
+								} catch (Exception e) {
+									// probably not in the system
+									dataSysMeta = null;
 								}
-
-								// update the values
-								HazelcastService.getInstance().getSystemMetadataMap().put(dataSysMeta.getIdentifier(), dataSysMeta);
+								//dataSysMeta = IdentifierManager.getInstance().getSystemMetadata(dataGuidString);
+							} catch (McdbDocNotFoundException nf) {
+								// we didn't find it
+								dataSysMeta = null;
+							}
 								
-
-							} catch (McdbDocNotFoundException mdnf) {
-								mdnf.printStackTrace();
-								throw mdnf;
-							} catch (NumberFormatException nfe) {
-								nfe.printStackTrace();
-								throw nfe;
-							} catch (AccessionNumberException ane) {
-								ane.printStackTrace();
-								throw ane;
-							} catch (SQLException sqle) {
-								sqle.printStackTrace();
-								throw sqle;
-							} catch (NoSuchAlgorithmException nsae) {
-								nsae.printStackTrace();
-								throw nsae;
-							} catch (IOException ioe) {
-								ioe.printStackTrace();
-								throw ioe;
-							} catch (PropertyNotFoundException pnfe) {
-								pnfe.printStackTrace();
-								throw pnfe;
-							} catch (BaseException be) {
-								be.printStackTrace();
-								throw be;
-							}	
+							// we'll have to generate it	
+							if (dataSysMeta == null) {
+								// System metadata for data doesn't exist yet, so create it
+								logMetacat.debug("There was not an existing system metadata document for " + dataDocLocalId);
+								try {
+									logMetacat.debug("Creating a system metadata " + "document for " + dataDocLocalId);
+									dataSysMeta = createSystemMetadata(dataDocLocalId, includeORE);
+	
+									// now look it up again
+									dataGuidString = IdentifierManager.getInstance().getGUID(dataDocid, dataRev);
+	
+									// set the guid
+									dataGuid.setValue(dataGuidString);
+	
+									// set object format
+									logMetacat.debug("Updating system metadata for "
+													+ dataGuid.getValue() + " to "
+													+ dataDocMimeType);
+									try {
+										ObjectFormatIdentifier fmt = 
+											ObjectFormatCache.getInstance().getFormat(dataDocMimeType).getFormatId();
+										dataSysMeta.setFormatId(fmt);
+									} catch (NotFound nfe) {
+										logMetacat.debug("Couldn't find format identifier for: "
+														+ dataDocMimeType
+														+ ". Setting it to application/octet-stream.");
+										ObjectFormatIdentifier newFmtid = new ObjectFormatIdentifier();
+										newFmtid.setValue("application/octet-stream");
+									}
+	
+									// update the values
+									HazelcastService.getInstance().getSystemMetadataMap().put(dataSysMeta.getIdentifier(), dataSysMeta);
+									
+	
+								} catch (McdbDocNotFoundException mdnf) {
+									mdnf.printStackTrace();
+									throw mdnf;
+								} catch (NumberFormatException nfe) {
+									nfe.printStackTrace();
+									throw nfe;
+								} catch (AccessionNumberException ane) {
+									ane.printStackTrace();
+									throw ane;
+								} catch (SQLException sqle) {
+									sqle.printStackTrace();
+									throw sqle;
+								} catch (NoSuchAlgorithmException nsae) {
+									nsae.printStackTrace();
+									throw nsae;
+								} catch (IOException ioe) {
+									ioe.printStackTrace();
+									throw ioe;
+								} catch (PropertyNotFoundException pnfe) {
+									pnfe.printStackTrace();
+									throw pnfe;
+								} catch (BaseException be) {
+									be.printStackTrace();
+									throw be;
+								}	
+								
+							}
 							
-						}
-						
-						// part of the ORE package
-						dataIds.add(dataGuid);
-
-					} // end if (EML package)
-
-				} // end for (data entities)
-				
+							// part of the ORE package
+							dataIds.add(dataGuid);
+	
+						} // end if (EML package)
+	
+					} // end for (data entities)
+					
+	            } // data entities not null
+	            
 				// ORE map
 				if (includeORE) {
 			        if (!dataIds.isEmpty()) {
Index: src/edu/ucsb/nceas/metacat/oaipmh/provider/server/catalog/MetacatCatalog.java
===================================================================
--- src/edu/ucsb/nceas/metacat/oaipmh/provider/server/catalog/MetacatCatalog.java	(revision 6743)
+++ src/edu/ucsb/nceas/metacat/oaipmh/provider/server/catalog/MetacatCatalog.java	(revision 6744)
@@ -90,59 +90,30 @@
    * that are publicly accessible
    */
   private final String QUERY =
-  "SELECT docid, doctype, date_updated " +
-  "FROM xml_documents " +
-  "WHERE doctype like 'eml://ecoinformatics.org/eml-2%' AND " + 
-  "  (docid IN " +
-  "     (SELECT docid " +
-  "      FROM xml_access " +
-  "      WHERE( (lower(principal_name) = 'public') AND " +
-  "             perm_type = 'allow' AND " +
-  "             permission > 3" +
-  "           )" +
-  "     )" +
-  "   AND " +
-  "   docid NOT IN " +
-  "     (SELECT docid " +
-  "      FROM xml_access " +
-  "      WHERE( (lower(principal_name) = 'public') AND " +
-  "             perm_type = 'deny' AND " +
-  "             perm_order ='allowFirst' AND " +
-  "             permission > 3" +
-  "           )" +
-  "     )" +
-  "  )";
+  "SELECT xd.docid, xd.doctype, xd.date_updated " +
+  "FROM xml_documents xd, identifier id " +
+  "WHERE xd.doctype like 'eml://ecoinformatics.org/eml-2%' " +
+  " AND xd.docid = id.docid " +
+  " AND xd.rev = id.rev " +
+  // ALLOW rule
+  " AND id.guid IN " +
+  "     (SELECT guid " +
+  "     FROM xml_access " +
+  "		AND lower(principal_name) = 'public' " +
+  " 	AND perm_type = 'allow' " +
+  " 	AND permission > 3" +
+  "		) " +
+  // DENY rules?
+  " AND id.guid NOT IN " +
+  "     (SELECT guid " +
+  "     FROM xml_access " +
+  "     WHERE lower(principal_name) = 'public' " +
+  "		AND perm_type = 'deny' " +
+  "		AND perm_order ='allowFirst' " +
+  "		AND permission > 3 " +
+  "     ) ";
   
   
-  /*
-   * QUERY string to determine the most recent 'date_updated' value stored
-   * in Metacat's 'xml_documents' table.
-   */
-  private final String LAST_UPDATED_QUERY =
-  "SELECT MAX(date_updated) " +
-  "FROM xml_documents " +
-  "WHERE doctype like 'eml://ecoinformatics.org/eml-2%' AND " + 
-  "  (docid IN " +
-  "     (SELECT docid " +
-  "      FROM xml_access " +
-  "      WHERE( (lower(principal_name) = 'public') AND " +
-  "             perm_type = 'allow' AND " +
-  "             permission > 3" +
-  "           )" +
-  "     )" +
-  "   AND " +
-  "   docid NOT IN " +
-  "     (SELECT docid " +
-  "      FROM xml_access " +
-  "      WHERE( (lower(principal_name) = 'public') AND " +
-  "             perm_type = 'deny' AND " +
-  "             perm_order ='allowFirst' AND " +
-  "             permission > 3" +
-  "           )" +
-  "     )" +
-  "  )";
-  
-  
 /* Constructors */
   
   public MetacatCatalog(Properties properties) {
Index: src/edu/ucsb/nceas/metacat/Sitemap.java
===================================================================
--- src/edu/ucsb/nceas/metacat/Sitemap.java	(revision 6743)
+++ src/edu/ucsb/nceas/metacat/Sitemap.java	(revision 6744)
@@ -105,9 +105,11 @@
             // TODO: make the doctype configurable in the query
             String sql =
             	"SELECT xml_documents.docid, xml_documents.rev " +
-            	"FROM xml_documents, xml_access " +
+            	"FROM xml_documents, xml_access, identifier " +
                 "WHERE xml_documents.doctype LIKE 'eml:%' " + 
-                "AND xml_documents.docid = xml_access.docid " +
+                "AND xml_documents.docid = identifier.docid " +
+                "AND xml_documents.rev = identifier.rev " +
+                "AND identifier.guid = xml_access.guid " +
                 "AND xml_access.principal_name = 'public' " +
                 "AND xml_access.perm_type = 'allow' " +
                 "order by docid, rev";
Index: src/edu/ucsb/nceas/metacat/XMLQueryresultAccess.java
===================================================================
--- src/edu/ucsb/nceas/metacat/XMLQueryresultAccess.java	(revision 6743)
+++ src/edu/ucsb/nceas/metacat/XMLQueryresultAccess.java	(revision 6744)
@@ -95,20 +95,6 @@
 	 */
 	protected BaseDAO populateDAO(ResultSet resultSet) throws SQLException {
 
-//		XMLAccessDAO xmlAccessDAO = new XMLAccessDAO();
-//		xmlAccessDAO.setDocId(resultSet.getString("docid"));
-//		xmlAccessDAO.setAccessFileId(resultSet.getString("accessfileid"));
-//		xmlAccessDAO.setPrincipalName(resultSet.getString("principal_name"));
-//		xmlAccessDAO.setPermission(resultSet.getLong("permission"));
-//		xmlAccessDAO.setPermType(resultSet.getString("perm_type"));
-//		xmlAccessDAO.setPermOrder(resultSet.getString("perm_order"));
-//		xmlAccessDAO.setBeginTime(resultSet.getDate("begin_time"));
-//		xmlAccessDAO.setEndTime(resultSet.getDate("end_time"));
-//		xmlAccessDAO.setTicketCount(resultSet.getLong("ticket_count"));
-//		xmlAccessDAO.setSubTreeId(resultSet.getString("subtreeid"));
-//		xmlAccessDAO.setStartNodeId(resultSet.getString("startnodeid"));
-//		xmlAccessDAO.setEndNodeId(resultSet.getString("endnodeid"));
-
 		return null;
 	}
 	
